Viznut/Ocsa presents : Bouncing Ball II for unexpanded Vic 20

This demo won the Alternative Party '98 in Turku, Finland.

The name?

  There was a great demo called 'bouncing ball' in the end of the vic20
  owner's guide (if I remember correctly, my book nowadays lacks those
  pages). It bounced a ball (a shift+q) around the screen and was so
  great I decided to name this demo after it.

It's made with a pc under msdos.

- Tested with PCVIC by B.W. van Schooten.
- Compiled with C64asm by Balint Toth. I could have used DASM but I
  already had some C64asm stuff ready and didn't want to convert it.
- Source edited with qedit (msdos) and joe (linux)
- Music (at least finding the notes) with scream tracker 3.
- Lookup tables made with gwbasic by microsoft :)
- The .d64 is made with c64s.

Why?!?!?

- My vic's keyboard has lost its great sensitivity and touch during
  these 13 years. (At least A, space, leftshift and return don't work at
  all. Several other keys such as inst/del work just barely.)
- There is no decent native assembler for vic 20, at least not for
  systems without a >=8kb ram expansion.
- I have no working x1541 cable (and even my 1541 seems to be broken).
  Couldn't fix this early enough.
- PCVic is damn fast (full speed on my 386/33) mainly because it tweaks
  everything out of vga textmode (yep, even those 4-color characters)
  and adlib (even the noise sounds correct). Unfortunately it does not
  emulate any disk/tape operations nor any raster stuff. I've heard that
  Vice was quite good and for unix but I haven't tested it out yet.

I have no machine to run this on, help me???

- Get an emulator. Search "pcvic" with altavista and don't forget to dl
  those rom images. If you need the roms separately (i.e. for vice)
  they're at ftp.funet.fi/pub/cbm/vic20/firmware/ (if i remember
  correctly)

What does it do? How did you do it??

- First of all, the effects are quite simple. I had no time for trying
  to do any filled vectors etc. I could also have done some fancy
  graphics or even render some torus frames with povray but I had no
  time. I also had a half-finished julia morpher but there wasn't enough
  space for a decent C^2 lookup table.

- 0intro.prg: A parallax starfield, a parallax scroller and a writer.
  The stars are redefined gfx characters with each horizontal line
  scrolling bit-by-bit in a different frequency. The parallax scroller
  rols the tree and the mountain separately and ors them together
  afterwards.

- 1rave.prg: Some interference stuff and a jumping ravedood. The
  interference is just about eXclusive-orring two gfx buffers with each
  other and storing the result to the gfxchar space. Each of the buffers
  consists of 64 characters (512 bytes). The first one is scrolled
  horizontally every irq (using rol) and the vertical scroll of the
  second one is just about changing the other start address of the
  xorloop.

- 2tunnel.prg: A texture tunnel. The texture is 16x16 (256 bytes) and is
  pointed to by a 2048-byte (32x64 pixels) lookup table. The texture
  table is scrolled every 1/50 secs and you know the rest.
  The buffer containing the tunnel image consists of 64 characters (512
  bytes). All this leaves about 768 bytes for dezign & music.

- 3end.prg: A sinus scrolly. The horizontal panning register of Vic-I
  has the max accuracy of 4 pixels. So even if you want a standard
  one-pixel-per-frame horizontal scroll you need to use a buffer and rol
  the image one bit to the left each frame.
  Turning this into a zigzag/sinus is just about adding some
  offsets to the rol pipeline.
  Had no time to draw a stunning logo so there's the classic shift+M/N
  labyrinth instead :)

Greetz

- The Damage guys for 'loaning' their disk drive during the party and
  converting the d64 into a real disk.
- The guys whose names I don't remember for loaning their own vic20
  during the compo.
- Ravel, Kameli, Speedo/Haujobb, Inka, Setok/Aggression (& other
  organizers), Marq/L!T, Neckfreak/Bandwagon, Idiot/Static, 216/MFX and
  other ppl at the party.
- Eskoensio Pipatti of MikroBitti for writing the book "Basicista
  Konekieleen" :) Even though it's damn stupid it worked as a reference
  guide.
- M.Makela and other people involved in making the demo "Veni Vidi Vic"
  (I found a lot of useful things in your source code)
- All the "real elites" for going to tg98 instead (no offence :)

ocsa homepage:     http://www.hytti.uku.fi/~vheikkil/ocsa/
viznut's homepage: http://www.hytti.uku.fi/~vheikkil/
email:             vheikkil@hytti.uku.fi

